package com.loganmagnan.unlimiteditems.managers;

import com.loganmagnan.unlimiteditems.UnlimitedItems;
import com.loganmagnan.unlimiteditems.playerdata.PlayerData;
import lombok.Getter;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitRunnable;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import java.util.UUID;

public class PlayerDataManager {

	private UnlimitedItems main = UnlimitedItems.getInstance();

	@Getter private final Map<UUID, PlayerData> players = new HashMap<>();

	public PlayerData getOrCreate(UUID uniqueId) {
		return this.players.computeIfAbsent(uniqueId, PlayerData::new);
	}

	public PlayerData getPlayerData(UUID uniqueId) {
		return this.players.getOrDefault(uniqueId, new PlayerData(uniqueId));
	}

	public Collection<PlayerData> getAllPlayers() {
		return this.players.values();
	}

	public void loadPlayerData(PlayerData playerData) {
		playerData.setLoaded(true);
	}

	public void savePlayerData(PlayerData playerData) {

	}

	public void deletePlayer(UUID uniqueId) {
		this.main.getServer().getScheduler().runTaskAsynchronously(this.main, () -> {
			this.savePlayerData(this.players.get(uniqueId));
			this.players.remove(uniqueId);
		});
	}
}
