package com.loganmagnan.unlimiteditems.menusystem.menu;

import com.loganmagnan.unlimiteditems.UnlimitedItems;
import com.loganmagnan.unlimiteditems.menusystem.ItemStackButton;
import com.loganmagnan.unlimiteditems.menusystem.Menu;
import com.loganmagnan.unlimiteditems.menusystem.PlayerMenuUtil;
import com.loganmagnan.unlimiteditems.playerdata.PlayerData;
import com.loganmagnan.unlimiteditems.playerdata.PlayerSettings;
import com.loganmagnan.unlimiteditems.utils.ColorUtils;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.ItemStack;

import java.util.ArrayList;
import java.util.List;

public class SettingsSelectorMenu extends Menu {

    private UnlimitedItems main = UnlimitedItems.getInstance();

    public SettingsSelectorMenu(PlayerMenuUtil playerMenuUtil) {
        super(playerMenuUtil);
    }

    @Override
    public String getMenuName() {
        return ColorUtils.getMessageType(this.main.getMenusConfig().getConfig().getString("MENUS.SETTINGS.TITLE"));
    }

    @Override
    public int getSlots() {
        return this.main.getMenusConfig().getConfig().getInt("MENUS.SETTINGS.SIZE");
    }

    @Override
    public void handleMenu(InventoryClickEvent event) {
        Player player = (Player) event.getWhoClicked();

        PlayerData playerData = this.main.getPlayerDataManager().getPlayerData(player.getUniqueId());

        PlayerSettings playerSettings = playerData.getPlayerSettings();

        if (event.getView().getTitle().equalsIgnoreCase(ColorUtils.getMessageType(this.main.getMenusConfig().getConfig().getString("MENUS.SETTINGS.TITLE")))) {
            switch (event.getCurrentItem().getType()) {
                case NETHER_STAR:
                    playerSettings.setUnlimitedItems(!playerSettings.isUnlimitedItems());

                    break;
            }

            new SettingsSelectorMenu(this.playerMenuUtil).open(player);
        }
    }

    @Override
    public void setMenuItems(Player player) {
        PlayerData playerData = this.main.getPlayerDataManager().getPlayerData(player.getUniqueId());

        PlayerSettings playerSettings = playerData.getPlayerSettings();

        this.setFillerGlass();

        List<String> unlimitedItemsLore = new ArrayList<String>(this.main.getMenusConfig().getConfig().getStringList("MENUS.SETTINGS.SETTINGS.UNLIMITED-ITEMS.LORE"));
        unlimitedItemsLore.add((playerSettings.isUnlimitedItems() ? this.main.getMenusConfig().getConfig().getString("MENUS.SETTINGS.ENABLED") : this.main.getMenusConfig().getConfig().getString("MENUS.SETTINGS.UNSELECTED")) + " Unlimited items enabled");
        unlimitedItemsLore.add((!playerSettings.isUnlimitedItems() ? this.main.getMenusConfig().getConfig().getString("MENUS.SETTINGS.DISABLED") : this.main.getMenusConfig().getConfig().getString("MENUS.SETTINGS.UNSELECTED")) + " Unlimited items disabled");

        ItemStackButton unlimitedItemsItemStackButton = new ItemStackButton(
                this.main.getMenusConfig().getConfig().getString("MENUS.SETTINGS.SETTINGS.UNLIMITED-ITEMS.NAME"),
                unlimitedItemsLore,
                Material.getMaterial(this.main.getMenusConfig().getConfig().getString("MENUS.SETTINGS.SETTINGS.UNLIMITED-ITEMS.MATERIAL")),
                0,
                1);

        ItemStack unlimitedItemsItemStack = unlimitedItemsItemStackButton.makeItemStack();

        this.inventory.setItem(this.main.getMenusConfig().getConfig().getInt("MENUS.SETTINGS.SETTINGS.UNLIMITED-ITEMS.SLOT"), unlimitedItemsItemStack);
    }
}
